%define kmod_name nilfs
%define kmod_name2 %{kmod_name}2
#
BuildRequires:	e2fsprogs-devel
Source10: kmodtool_%{kmod_name2}
Source11: find-requires.%{kmod_name2}
Source12: find-requires.ksyms.%{kmod_name2}
%define kmodtool bash %{SOURCE10}
%{!?kversion: %define kversion 2.6.18-194.el5}

%define kverrel %(%{kmodtool} verrel %{?kversion} 2>/dev/null)

%define upvar ""
%ifarch i686
%define PAEvar PAE
%endif
%ifarch i686 x86_64 ia64
%define xenvar xen
%endif
%ifarch ppc64
%define kdumpvar kdump
%endif 

%{!?kvariants: %define kvariants %{?upvar} %{?xenvar} %{?kdumpvar} %{?PAEvar}}

# hint: this can he overridden with "--define kvariant foo bar" on the rpmbuild command line, e.g.
# --define 'kvariant "" smp' 

Name:           %{kmod_name}-kmod
Version:        2.0.20
Release:        4.%(echo %{kverrel} | tr - _)
Summary:        %{kmod_name} kernel module

License:        GPL
Group:          System Environment/Kernel
URL:            http://www.nilfs.org/

Source0:        %{kmod_name}-%{version}.tar.bz2
Patch1:		kern-feature-fmode-t.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
ExclusiveArch:	i686 ia64 ppc64 s390x x86_64

# Override find_provides to use a script that provides "kernel(symbol) = hash".
# Pass path of the RPM temp dir containing kabideps to find-provides script.
%global _use_internal_dependency_generator 0
%define __find_requires %{SOURCE11} %{name}

%description
nilfs - A new implementation of a log-structured file system.

# magic hidden here:
%{expand:%(%{kmodtool} rpmtemplate_kmp %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null)}


%prep
# to understand the magic better or to debug it, uncomment this:
# {kmodtool} rpmtemplate_kmp %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null
# sleep 5
%setup -q -c -T -a 0
pushd %{kmod_name}-%{version}
%patch1 -p1
popd
for kvariant in %{kvariants} ; do
    %{__cp} -a %{kmod_name}-%{version} _kmod_build_${kvariant}
done


%build
for kvariant in %{kvariants} ; do
    ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
    pushd _kmod_build_$kvariant/fs
    %{__make} -C "${ksrc}" modules M=$PWD
    popd
done


%install
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=extra/%{kmod_name2}
for kvariant in %{kvariants} ; do
    ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
    pushd _kmod_build_$kvariant/fs
    %{__make} -C "${ksrc}" modules_install M=$PWD
    popd
done
# Temporarily executable for stripping, fixed later in %%files.
# chmod u+x $RPM_BUILD_ROOT/lib/modules/*/extra/%{kmod_name2}/*
# find ${INSTALL_MOD_PATH} -type f -name \*.ko -exec strip --strip-debug \{\} \;

%clean
%{__rm} -rf $RPM_BUILD_ROOT

%changelog
* Sun Jul 4 2010 Seiji Kihara <kihara@osrg.net>
- added a patch for 2.0.20 with rhel/centos 5.4 and above.
* Sun Oct 11 2009 Seiji Kihara <kihara@osrg.net>
- modified to work with RHEL/CentOS 5 weak updates.
